Documentation Index
Fetch the complete documentation index at: https://cdktn.io/docs/llms.txt
Use this file to discover all available pages before exploring further.
Initializers
import cdktn
cdktn.DataTerraformRemoteStateGcs(
scope: Construct,
id: str,
defaults: typing.Mapping[typing.Any] = None,
workspace: str = None,
bucket: str,
access_token: str = None,
credentials: str = None,
encryption_key: str = None,
impersonate_service_account: str = None,
impersonate_service_account_delegates: typing.List[str] = None,
kms_encryption_key: str = None,
prefix: str = None,
storeage_custom_endpoint: str = None
)
| Name | Type | Description |
|---|
scope | constructs.Construct | No description. |
id | str | No description. |
defaults | typing.Mapping[typing.Any] | No description. |
workspace | str | No description. |
bucket | str | (Required) The name of the GCS bucket. |
access_token | str | (Optional) A temporary [OAuth 2.0 access token] obtained from the Google Authorization server, i.e. the Authorization: Bearer token used to authenticate HTTP requests to GCP APIs. This is an alternative to credentials. If both are specified, access_token will be used over the credentials field. |
credentials | str | (Optional) Local path to Google Cloud Platform account credentials in JSON format. |
encryption_key | str | (Optional) A 32 byte base64 encoded ‘customer supplied encryption key’ used to encrypt all state. |
impersonate_service_account | str | (Optional) The service account to impersonate for accessing the State Bucket. |
impersonate_service_account_delegates | typing.List[str] | (Optional) The delegation chain for an impersonating a service account. |
kms_encryption_key | str | (Optional) A Cloud KMS key (‘customer-managed encryption key’) used when reading and writing state files in the bucket. |
prefix | str | (Optional) GCS prefix inside the bucket. |
storeage_custom_endpoint | str | (Optional) A URL containing three parts: the protocol, the DNS name pointing to a Private Service Connect endpoint, and the path for the Cloud Storage API (/storage/v1/b). |
scopeRequired
- Type: constructs.Construct
idRequired
defaultsOptional
- Type: typing.Mapping[typing.Any]
workspaceOptional
bucketRequired
(Required) The name of the GCS bucket.
This name must be globally unique.
access_tokenOptional
(Optional) A temporary [OAuth 2.0 access token] obtained from the Google Authorization server, i.e. the Authorization: Bearer token used to authenticate HTTP requests to GCP APIs. This is an alternative to credentials. If both are specified, access_token will be used over the credentials field.
credentialsOptional
(Optional) Local path to Google Cloud Platform account credentials in JSON format.
If unset, Google Application Default Credentials are used.
The provided credentials must have Storage Object Admin role on the bucket.
Warning: if using the Google Cloud Platform provider as well,
it will also pick up the GOOGLE_CREDENTIALS environment variable.
encryption_keyOptional
(Optional) A 32 byte base64 encoded ‘customer supplied encryption key’ used to encrypt all state.
impersonate_service_accountOptional
(Optional) The service account to impersonate for accessing the State Bucket.
You must have roles/iam.serviceAccountTokenCreator role on that account for the impersonation to succeed.
If you are using a delegation chain, you can specify that using the impersonate_service_account_delegates field.
Alternatively, this can be specified using the GOOGLE_IMPERSONATE_SERVICE_ACCOUNT environment variable.
impersonate_service_account_delegatesOptional
(Optional) The delegation chain for an impersonating a service account.
kms_encryption_keyOptional
(Optional) A Cloud KMS key (‘customer-managed encryption key’) used when reading and writing state files in the bucket.
Format should be projects/{{project}}/locations/{{location}}/keyRings/{{keyRing}}/cryptoKeys/{{name}}.
For more information, including IAM requirements, see Customer-managed Encryption Keys.
prefixOptional
(Optional) GCS prefix inside the bucket.
Named states for workspaces are stored in an object called < prefix >/< name >.tfstate.
storeage_custom_endpointOptional
(Optional) A URL containing three parts: the protocol, the DNS name pointing to a Private Service Connect endpoint, and the path for the Cloud Storage API (/storage/v1/b).
See here for more details
Methods
| Name | Description |
|---|
to_string | Returns a string representation of this construct. |
add_override | No description. |
override_logical_id | Overrides the auto-generated logical ID with a specific ID. |
reset_override_logical_id | Resets a previously passed logical Id to use the auto-generated logical id again. |
to_hcl_terraform | Adds this resource to the terraform JSON output. |
to_metadata | No description. |
to_terraform | Adds this resource to the terraform JSON output. |
get | No description. |
get_boolean | No description. |
get_list | No description. |
get_number | No description. |
get_string | No description. |
to_string
Returns a string representation of this construct.
add_override
def add_override(
path: str,
value: typing.Any
) -> None
pathRequired
valueRequired
override_logical_id
def override_logical_id(
new_logical_id: str
) -> None
Overrides the auto-generated logical ID with a specific ID.
new_logical_idRequired
The new logical ID to use for this stack element.
reset_override_logical_id
def reset_override_logical_id() -> None
Resets a previously passed logical Id to use the auto-generated logical id again.
def to_hcl_terraform() -> typing.Any
Adds this resource to the terraform JSON output.
def to_metadata() -> typing.Any
def to_terraform() -> typing.Any
Adds this resource to the terraform JSON output.
get
def get(
output: str
) -> IResolvable
outputRequired
get_boolean
def get_boolean(
output: str
) -> IResolvable
outputRequired
get_list
def get_list(
output: str
) -> typing.List[str]
outputRequired
get_number
def get_number(
output: str
) -> typing.Union[int, float]
outputRequired
get_string
def get_string(
output: str
) -> str
outputRequired
Static Functions
| Name | Description |
|---|
is_construct | Checks if x is a construct. |
is_terraform_element | No description. |
is_construct
import cdktn
cdktn.DataTerraformRemoteStateGcs.is_construct(
x: typing.Any
)
Checks if x is a construct.
Use this method instead of instanceof to properly detect Construct
instances, even when the construct library is symlinked.
Explanation: in JavaScript, multiple copies of the constructs library on
disk are seen as independent, completely different libraries. As a
consequence, the class Construct in each copy of the constructs library
is seen as a different class, and an instance of one class will not test as
instanceof the other class. npm install will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the constructs
library can be accidentally installed, and instanceof will behave
unpredictably. It is safest to avoid using instanceof, and using
this type-testing method instead.
xRequired
Any object.
import cdktn
cdktn.DataTerraformRemoteStateGcs.is_terraform_element(
x: typing.Any
)
xRequired
Properties
| Name | Type | Description |
|---|
node | constructs.Node | The tree node. |
cdktf_stack | TerraformStack | No description. |
fqn | str | No description. |
friendly_unique_id | str | No description. |
nodeRequired
The tree node.
cdktf_stackRequired
cdktf_stack: TerraformStack
fqnRequired
friendly_unique_idRequired
Constants
| Name | Type | Description |
|---|
tfResourceType | str | No description. |
tfResourceTypeRequired